{ ... }@args:

with builtins;

let
  fix = f: let x = f x; in x;

  readTree = import ./nix/readtree.nix {};

  # Tracking nixos-unstable as of 2020-08-22.
  nixpkgsCommit = "c59ea8b8a0e7f927e7291c14ea6cd1bd3a16ff38";
  nixpkgsSrc = fetchTarball {
    url = "https://github.com/NixOS/nixpkgs-channels/archive/${nixpkgsCommit}.tar.gz";
    sha256 = "1ak7jqx94fjhc68xh1lh35kh3w3ndbadprrb762qgvcfb8351x8v";
  };
  nixpkgs = import nixpkgsSrc {
    config.allowUnfree = true;
    config.allowBroken = true;
  };

in fix (self: rec {
  config = {
    hscloud = self // {
      root = ./.;
    };
    pkgs = nixpkgs;
    pkgsSrc = nixpkgsSrc;

    inherit (nixpkgs) lib stdenv;
  };

  bgpwtf = readTree config ./bgpwtf;
  cluster = readTree config ./cluster;
  ops = readTree config ./ops;

  pkgs = nixpkgs;
})
